/*
*
*	wave sampling freq. conv to 44.1kHz ver 0.4
*
*	WAVEt@C̃TvO[g44.1kHzɕϊ
*	x̓TvO[gƂ̍ŏ{̃TvO[gɕϊ, 
*	FIRɂLPF|44100HzɃ_ETvO
*	(FIR : JCU[, 48kHzLPF : 21500Hz)
*
*	܂o̓t@C`vZĂȂ
*	wavefs44 <name1> <name2> [g<gain>] [p<0..3>] [q] [f<Fc>] [o<N>]
*
*	name1 : source wave file name
*	name2 : destination wave file name
*	g<gain>  : amplitude parameter
*	p<0..3>  : precision(0:low, 1:mid, 2:High, 3:UltraHigh)
*		for 48kHz->44.1kHz(at K6-2/400), ĐԔ: 0:~0.4, 1:~1.5, 2:~3, 3:~4
*	q     : ro߃bZ[W}
*	f<Fc> : FcŃtB^JbgItgw
*	o<N>  : NŃtB^̔̒lw(ő65535)
*	s<N>  : Nŏowavet@C̃TvOgw(N=32/48)
*
*	version 0.1 bJ
*	version 0.2 ftHgQC255/256
*	            Oaǉ
*	            oߕ\ǉ
*	            oߕ\}IvVuqvǉ
*	            pIvVŌ߂Fs=32kHz̃tB^g/
*	            tB^g/włf/oIvVŒǉ
*	version 0.3 o̓t@CRIFF^ÕTCŶC
*	            oFs=32k/48kΉ
*	            plextor managerŌt@Cdata`NɒlȂ̂ɑΉ
*	version 0.4 TvOl𐮐lϊƂľܓɕύX
*	            ֌WȂf[^ǂݎ̂ď̏I~XC
*/

char verstr[]="0.4";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <math.h>

#ifndef M_PI
#  define M_PI	acos(-1.0)
#endif

double bessel0(double);
int main(int, char **);

struct ChunkWavFmt{	/* for chunk 'fmt ' */
	short type;	/* support only if this value == 1 (PCM) */
	short nch;	/* # of channel */
	long sps;	/* Sample per Sec. */
	long byteps;	/* bypeps == bsz * sampleps */
	short bsz;	/* bitps8~nch==bsz */
	short bitps;	/* ~sampleps==bps */
};

struct RiffTagFmt{
	union{
		char c[4];	/* if unknown tag, skip "size" */
		long v;
	}id;
	long size;	/* size in this tag */
};

struct SmplData{short l,r;};

union _4char{
	char c[4];	/* access at char */
	long dw;	/* access at DW */
};

union _4char KEYRIFF={'R','I','F','F'};
union _4char KEYWAVE={'W','A','V','E'};
union _4char KEYFMT={'f','m','t',' '};
union _4char KEYDATA={'d','a','t','a'};

#define BUFLEN	16384	/* sampling data input buffer */
#define OFNLEN	32
#define WINSIZ	65536	/* input data window size(buffering) K2ׂ̂ */

#define DefaultGain	255.0/256.0	/* level down to avoid overflow */

/* WAVE ܂ԂctB^萔 */
#define MAXFIRODR 65535	/* FIRtB^̕Б̍ől */
#define ALPHA 10.0	/* JCU[֐̐؂ꖡ */
#define FREQ44k	44100	/* o̓TvO[h */

/* ̓TvO[g/xʃp[^e[u */
/* FIRtB^̕Б(͂̒l2{+1) */
int firodr[6][4]={12287, 24575, 49151, 65535,	/* 3244.1, xႢ */
		 4095, 12287, 24575, 32767,	/* 4844.1, xႢ */
		12287, 24575, 49151, 65535,	/* 44.132, xႢ */
		   95,   191,   383,   511,	/* 4832, xႢ */
		   95,   191,   383,   511,	/* 3248, xႢ */
		 4095, 12287, 24575, 32767};	/* 44.148, xႢ */
/* Low Pass Filter Cut-off Freq.(for32k/48k) */
int lpfcof[6][4]={14500,15100,15540,15680,	/* 3244.1, xႢ */
		19400,21200,21400,21600,	/* 4844.1, xႢ */
		14500,15100,15540,15680,	/* 44.132, xႢ */
		14500,15100,15540,15680,	/* 4832, xႢ */
		14500,15100,15540,15680,	/* 3248, xႢ */
		19400,21200,21400,21600};	/* 44.148, xႢ */
/* zԃTvOgɑ΂W(͑) */
int isrmt[6]={441, 147, 320, 2, 3, 160};
/* zԃTvOgɑ΂W(o͑) */
int osrmt[6]={320, 160, 441, 3, 2, 147};

char inbuf[BUFLEN];
double hfir[MAXFIRODR+1];	/* FIRtB^We[u */

int main(int argc, char **argv)
{
	/* FILE *tfp;	 ꎞt@C|C^ */
	FILE *ifp, *ofp;	/* \[X/o̓t@C|C^ */
	
	struct RiffTagFmt tag;	/* tag buffer */
	struct ChunkWavFmt wfmt;	/* wave format data */
	long rlen;	/* remain length */
	long idv, i, j, k, l, ret;
	struct SmplData smpld[WINSIZ*2], smplo, *spp;	/* sample, max, min */
	double maxdl, maxdr;
	long iptr, optr, iscount, oscount, rsize;
	int firprec, ifrqflg, quiet;	/* FIR̐x(0:; 3:x), SRtO */
	int startf;
	long firodrv, frqo, datapos;
	int sptr, sptrr, eptr, eptrr;	/*  lp */
	int isrm, osrm, ismd, ismr;	/* WZop */
	double gain, suml, sumr;
	double frqc;	/* ܂ԂtB^ cut off freq. */
	double frqs;	/* zTvOg */
	double regv, wfnc, divisor, hgain;
	double fisec, fosec, prog;

	/* for test */
	/* printf("tag RIFF = %08X[%04s]\n", KEYRIFF.dw, &KEYRIFF.c);
	/*printf("tag WAVE = %08X[%04s]\n", KEYWAVE.dw, &KEYWAVE.c);
	printf("tag DATA = %08X[%04s]\n", KEYDATA.dw, &KEYDATA.c);
	*/

	/* copyright&usage */
	printf("Wave sampling frequency converter(wavefs44) version %s\n",verstr);
	puts("Copyright (c) 2000 by WTC\n");

	if(argc<3){
		puts("\nusage : wavefs44 <name1> <name2> [g<gain>] [p<0..3>]\n");
		puts("\tname1 : source wave file name\n");
		puts("\tname2 : destination wave file name\n");
		puts("\tggain  : amplitude parameter\n");
		puts("\tp<0..3>  : precision(0:low, 1:mid, 2:High, 3:UltraHigh)\n");
		puts("\ts<{32|48}> : output Fs(32:32kHz, 48:48kHz, none:44.1kHz)\n");
		puts("\tq     : quiet(suppress in-progress message)\n");
		return(-1);
	}

	/* step 1: t@CI[v */

	/* open input file */
	ifp=fopen(argv[1],"rb");
	if(ifp==NULL){
		printf("can't create input file %s.\n",argv[1]);
		return(0);
	}

	/* get output file name */
	/* printf("Create file name = %s\n",argv[2]); */
	ofp=fopen(argv[2],"wb");

	firprec=1;
	frqc=0;
	firodrv=0;
	gain=DefaultGain;
	quiet=0;		/* quiet option */
	frqo=FREQ44k;	/* default output Fs */
	ifrqflg = 0;

	for(i=3; i<argc; i++){
		switch(toupper(argv[i][0])){
		case 'P':	/* precision parameter */
			firprec=atoi(&(argv[i][1]));
			if((firprec<0)||(firprec>3)){
				printf("[p] parameter should be 0..3!\n");
				return(0);
			}
			break;
		case 'G':	/* gain parameter */
			gain=atof(&(argv[i][1]));
			break;
		case 'Q':	/* quiet option */
			quiet=1;
			break;
		case 'F':	/* Fc option */
			frqc=atoi(&(argv[i][1]));
			if((frqc<0)||(frqc>22050)){
				printf("[f] parameter should be 0..22050!\n");
				return(0);
			}
			break;
		case 'O':	/* FIR order option */
			firodrv=atoi(&(argv[i][1]));
			if((firodrv<0)||(firodrv>65535)){
				printf("[o] parameter should be 0..65535!\n");
				return(0);
			}
			break;
		case 'S':	/* output sampling freq. option */
			ret = atoi(&(argv[i][1]));
			switch(ret){
			case 32:	ifrqflg=2; frqo=32000; break;
			case 48:	ifrqflg=4; frqo=48000; break;
			default:
				printf("[s] parameter should be 32 or 44!\n");
				return(0);
			}
			break;
		default:
			printf("illegal parameter '%s'\n", argv[i]);
			return(0);
			break;
		}
	}

	printf("prec.:%d, gain:%3.1f\n", firprec, gain);

	/* step 2: mĂtH[}bg𒲂ׂ */

	/* step 2.1: RIFFt@C? */
	fread(&tag, 1, sizeof(struct RiffTagFmt), ifp);
	if(tag.id.v != KEYRIFF.dw){
		printf("tag %08X is not RIFF.\n", tag.id.v);
		return(0);
	}
	rlen = tag.size;

	/* step 2.2: WAVEt@C? */
	fread(&idv, 1, sizeof(idv), ifp);
	if(idv != KEYWAVE.dw){
		printf("tag %08X is not RIFF.\n", idv);
		return(0);
	}

	/* step 2.3: fmt`NTēǂݍ */
	ret=-1;
	do{	/* fmt`NT */
		fread(&tag, 1, sizeof(struct RiffTagFmt), ifp);
		if(tag.id.v != KEYFMT.dw){	/* tH[}bg`NłȂΓǂݎ̂ */
			i=tag.size;
			/* printf("not FMT tag %08X. skip %d bytes.\n", tag.id.v, i); */
			while(i>0 && ret!=0){
				j=i;
				if(j>BUFLEN)	j=BUFLEN;
				ret=fread(&inbuf, 1, j, ifp);
				i-=ret;
			}
		}
	}while(tag.id.v != KEYFMT.dw && ret!=0);	/* fmt`NG[܂ő */

	fread(&wfmt, 1, sizeof(wfmt), ifp);	/* fmt`Nǂݍ */
	printf("Wav format : type:%d, ", wfmt.type);
	printf("%d ch, ", wfmt.nch);
	printf("%d S/sec, ", wfmt.sps);
	printf("%d byte/sec, ", wfmt.byteps);
	printf("%d byte/sample, ", wfmt.bsz);
	printf("%d bps\n", wfmt.bitps);

	/* step 2.4: T|[gtH[}bgO */
	if(wfmt.type != 1){
		printf("not PCM format coding.\n");
		return(0);
	}
	if(wfmt.nch != 2){
		printf("not STEREO file.\n");
		return(0);
	}
	if(wfmt.bitps != 16){
		printf("not 16bit STEREO file.\n");
		return(0);
	}
	if(wfmt.bitps * wfmt.nch / 8 != wfmt.bsz){
		printf("unknown sample data format.\n");
		return(0);
	}
	if(wfmt.sps * wfmt.bsz != wfmt.byteps){
		printf("unknown sample data format.\n");
		return(0);
	}

	/* step 3 f[^ǂݏo */

	/* step 3.1: data`NTăTCYl */
	ret=-1;
	do{	/* data`NT */
		fread(&tag, 1, sizeof(struct RiffTagFmt), ifp);
		if(tag.id.v != KEYDATA.dw){	/* f[^`NłȂΓǂݎ̂ */
			i=tag.size;
			/* printf("not DATA tag %08X. skip %d bytes.\n", tag.id.v, i); */
			while(i>0 && ret!=0){
				j=i;
				if(j>BUFLEN)	j=BUFLEN;
				ret=fread(&inbuf, 1, j, ifp);
				i-=ret;
			}
		}
	}while(tag.id.v != KEYDATA.dw && ret!=0);	/* data`NG[܂ő */

	datapos = ftell(ifp);
	if(tag.size==0)	rlen -= datapos-sizeof(struct RiffTagFmt);
					/* TCY0̏ꍇRIFF^OtZ */
	else	rlen = tag.size;

	iscount = rlen/wfmt.bsz;

	switch(wfmt.sps){
	case 32000:
		if(ifrqflg==2)	ifrqflg=-1;
		break;
	case 44100:
		if(ifrqflg==0)	ifrqflg=-1;
		else if(ifrqflg==4)	ifrqflg=5;
		break;
	case 48000:
		if(ifrqflg==4)	ifrqflg=-1;
		else		ifrqflg+=1;
		break;
	default:
		ifrqflg = -1;
		break;
	}
	if(ifrqflg<0){
		printf("input freq. %d Hz / output freq. %d Hz combination unsupported.\n", wfmt.sps, frqo);
		return(-1);
	}
	else	printf("input freq. / output freq. combination code = %d.\n", ifrqflg);

	isrm = isrmt[ifrqflg];
	osrm = osrmt[ifrqflg];
	frqs = frqo*osrm;
	if(frqc==0)	frqc = lpfcof[ifrqflg][firprec];
	if(firodrv==0)	firodrv = firodr[ifrqflg][firprec];
	printf("FIR order:% d, cutoff freq.=%.0f Hz, virtual high sampling rate=%.0f Hz\n",firodrv*2+1,  frqc, frqs);

	oscount = iscount%osrm*isrm/osrm;	/* [؂グZ */
	if(iscount%osrm*isrm%osrm)	oscount++;	/* [؂グZ */
	oscount+= (iscount / osrm)*isrm;	/* ŏ{ł̉Z */

	fisec=(double)iscount/(double)wfmt.sps;
	fosec=(double)oscount/(double)frqo;

	/* printf("DATA start at 0x%08X\n", datapos); */
	printf("input : %d sample, %4.6f second.\n", iscount, fisec);
	printf("output: %d sample, %4.6f second.\n", oscount, fosec);
	if(fisec>fosec)	printf("input length is longer\n");
	if(fisec<fosec)	printf("output length is longer\n");

	/* o̓t@C̃wb_o */
	/* step 4.1: RIFF`No */
	tag.id.v = KEYRIFF.dw;
	tag.size = sizeof(idv) + sizeof(struct RiffTagFmt)*2 + sizeof(wfmt) + oscount*wfmt.bsz;

	printf("Writing file %s size = %d\n", argv[2], tag.size + sizeof(struct RiffTagFmt));

	fwrite(&tag, 1, sizeof(struct RiffTagFmt), ofp);	/* write "RIFF" */
	/* step 4.2.3: "WAVE"o */
	idv = KEYWAVE.dw;
	fwrite(&idv, 1, sizeof(idv), ofp);
	/* step 4.2.4: fmt`No */
	tag.id.v = KEYFMT.dw;
	tag.size = sizeof(wfmt);
	fwrite(&tag, 1, sizeof(struct RiffTagFmt), ofp);	/* write "fmt " */
	wfmt.sps = frqo;			/* Fs(out)kHzTvɋ */
	wfmt.byteps = wfmt.sps * wfmt.bsz;
	fwrite(&wfmt, 1, sizeof(wfmt), ofp);	/* Tv[gȊOefmt`NCg*/

	/* step 4.2: DATA`No */
	tag.id.v = KEYDATA.dw;
	tag.size = oscount*wfmt.bsz;				/* o̓oCg͎Zo */
	fwrite(&tag, 1, sizeof(struct RiffTagFmt), ofp);	/* write "DATA" */

	/* step 4.3: FIRɂfW^tB^\@*/
	divisor=bessel0(ALPHA);
	/* -N`+N܂ł̃tB^W߂ */
	hgain=2.0*isrm*frqc/frqs;
	hfir[0]=hgain;
	for(i=1; i<=firodrv; i++){
		regv = (double)i/(double)(firodrv);
		regv = regv*regv;
		wfnc=bessel0(sqrt(1.0-regv)*ALPHA)/divisor;	/* ֐ */
		regv=2.0*M_PI*frqc/frqs*(double)i;
		hfir[i]=hgain*sin(regv)/regv*wfnc;
		/* printf("%d\t%f\n", i, hfir[i]); */
	}

	/* AbvTvO/_ETvO̍̃p[^ */

	ismd=osrm/isrm;	/* (isrd, ismr)osrm/isrm̔\ */
	ismr=osrm%isrm;

	/* step 4.4: ̓t@Cǂ݂݃tB^Jn */
	maxdl=0; maxdr=0;
	ret =4;
	startf = -1;
	k=1;
	iptr=0;
	optr=0;
	suml=0.0;
	sumr=0.0;
	memset(smpld, 0, sizeof(smpld));
	sptr=-(firodrv/isrm);
	sptrr=-(firodrv%isrm);
	eptr=firodrv/isrm;
	eptrr=firodrv%isrm;

	while(optr < oscount){	/* o͍ς݃Tv\ɒB܂ */
		/* printf("%d:%d ` %d:%d EEE%d\t", sptr, sptrr, eptr, eptrr, eptr-sptr); */
		if(iptr<=eptr){	/* EBhE[iptrOɂƃf[^ǂ݂ */
			k=1-k;
			if(iptr>=iscount){	/* łɃt@C̓ǂ݂ݏIĂ */
				/* t@Cǂޑ0Ŗ߂ */
				memset(&smpld[k*WINSIZ], 0, sizeof(struct SmplData)*WINSIZ);
			}
			else{
				rsize = WINSIZ;
				if((iptr+rsize) > iscount){
					rsize = iscount - iptr;
					for(i=WINSIZ-1;i>=rsize;i--){	/* [0ŋl߂ */
						smpld[k*WINSIZ+i].l=0;
						smpld[k*WINSIZ+i].r=0;
					}
				}
				iptr+=WINSIZ;	/* f[^IĂĂ|C^͐i߂Ă */
				/* WINSIZsample(܂͏I܂)ǂݍ */
				ret = fread(&smpld[k*WINSIZ], sizeof(struct SmplData), rsize, ifp);
			}
			/* printf("brock read : datapos = %d sample\n", iptr); */
			if(!quiet){
				prog=(double)optr*100.0/(double)oscount;
				printf("processing %3.0f %%.\r", prog);
			}
		}/* ܂łŃf[^[U */
		/* l */
		suml=0.0;
		sumr=0.0;
		/* FIRΏۃTv͈͂ɂă[v */
		j=-firodrv-sptrr;	/* -FIRTODRHʒu[ꂽʒu */
		/* printf("%d ` ", j); */
		for(i=sptr; i<=eptr; i++, j+=isrm){
			l=j;
			if(j<0)	l=-j;	/* K̒lɒ */
			spp=&smpld[i&(WINSIZ*2-1)];
			hgain=hfir[l];
			suml=suml+hgain*(double)spp->l;
			sumr=sumr+hgain*(double)spp->r;
		}
		/* printf("%d\n", j);*/
		regv=suml*gain;
		if(maxdl< regv) maxdl = regv; 
		if(maxdl< -regv) maxdl = -regv; 
		if(regv>32767)	regv=32767;
		if(regv<-32768)	regv=-32768;
		smplo.l=(short)floor(regv+0.5);
		regv=sumr*gain;
		if(maxdr< regv) maxdr = regv; 
		if(maxdr< -regv) maxdr = -regv; 
		if(regv>32767)	regv=32767;
		if(regv<-32768)	regv=-32768;
		smplo.r=(short)floor(regv+0.5);
		fwrite(&smplo, sizeof(smplo), 1, ofp);
		optr++;
		/* EBhEʒuČvZ */
		sptr+=ismd;
		sptrr+=ismr;
		if(sptrr>0){	sptrr-=isrm;	sptr++;}
		eptr+=ismd;
		eptrr+=ismr;
		if(eptrr>=isrm){	eptrr-=isrm;	eptr++;}
	}

	if(quiet){
		prog=(double)optr*100.0/(double)oscount;
		printf("processing 100 %. done.\n", 100.0);
	}
	printf("file[%s] max:(%.0f,%.0f)",argv[2], maxdl, maxdr);

	if((maxdl > 32767)||(maxdr > 32767))
		printf(" Overflow!");
	printf("\n");

	fclose(ofp);
	fclose(ifp);
	return(0);
}

double bessel0(double x){
	double part, ret, step;

	ret = 1.0;
	step = 1.0;
	part=(x/2.0)/step;

	while(part>1.0E-10){
		ret+=part*part;
		step+=1.0;
		part=part*(x/2.0)/step;
	}
	return(ret);
}
